com.ihr.xbrl.om.instance

## Class XBRLEntity

- java.lang.Object
- - com.ihr.xbrl.om.XMLFragment
  - - com.ihr.xbrl.om.instance.XBRLEntity

- All Implemented Interfaces:
    HasAdditionalEqualityForReassignation, XBRLRelationshipPoint, Thinable, XMLHasParent, java.lang.Cloneable, javax.xml.namespace.NamespaceContext

      public class XBRLEntity
      extends XMLFragment
      implements java.lang.Cloneable

  The Class XBRLEntity.
  Author:
    Ignacio

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static javax.xml.namespace.QName` | `entityNode` The Constant entityNode.

    - ### Fields inherited from class com.ihr.xbrl.om.XMLFragment

      `CONCEPT_LABEL, CONCEPT_QNAME, EASY_TO_READ, ELEMENT_LABEL, EMPTYRELATIONSHIPSITERATORINSTANCE, EMPTYXMLFRAGMENTITERATORINSTANCE, FACT_CONCEPT_DATATYPE, FACT_CONCEPT_LABEL, FACT_QNAME, HIDE_COMMON_ACCURACY, idQName, NO_POSITION, OrderComparator, OrderComparator2, PERIOD_TYPE, PERIOD_VALUE, SHORT_TEXT, SOURCE_DOCUMENT, XPATH, XPOINTER`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XBRLEntity(DTSContainer parent, java.lang.String scheme, java.lang.String identifier, XBRLSegment segment)` Creates a new Entity to be added to a context later.
    `XBRLEntity(DTSContainer parent, net.sf.saxon.s9api.XdmNode node)` Instantiates a new XBRL entity.
    `XBRLEntity(XBRLEntity other)` Instantiates a new XBRL entity.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` Frees-up used memory This method should not be invoqued on live objects in the DTS.
    `XBRLEntity` | `clone()`
    `XBRLEntity` | `clone(DTSContainer newDTS)` Clone.
    `boolean` | `equals(java.lang.Object other)` Sets a new XPathFunctionResolver for this object.
    `org.jdom.Element` | `generateNode(boolean relativize, java.net.URI base)` Serializes to a jdom Element the representation of the properties of this Information Item This method should be called from classes derived from this class
    `java.util.Iterator<XMLFragment>` | `getElements()` For complex type resources this returns an iterator with all children XML fragments This method may be overwriten by other classes in the hierarchy.
    `java.lang.String` | `getIdentifier()` Access to the identifier string on this entity.
    `net.sf.saxon.s9api.XdmNode` | `getIdentifierNode()` In principle this is used only within the formula processor.
    `java.lang.String` | `getScheme()` Access to the value of the Scheme on this entity.
    `XBRLSegment` | `getSegment()` Access to the segment object of this entity.
    `net.sf.saxon.s9api.XdmValue` | `getValue()` Returns the value of this node.
    `int` | `hashCode()`
    `boolean` | `s_equal2(java.lang.Object other)` Resolves s_equal2 comparison of this node against the other node.
    `void` | `setIdentifier(java.lang.String identifier)` Sets the identifier.
    `void` | `setScheme(java.lang.String scheme)` Sets the scheme.
    `void` | `setSegment(XBRLSegment segment)` Sets the segment.

    - ### Methods inherited from class com.ihr.xbrl.om.XMLFragment

      `addAttribute, addChild, addFromRelationship, addNamespace, addNamespace, addToRelationship, addXMLChild, changeBase, checkBase, delAttribute, delAttribute, equalXdmValues, evaluateBoolean, evaluateList, evaluateNode, evaluateNumber, evaluateString, generateId, generateNodeNamespacesAndAttributes, generateNodeValue, generatePrefix, getAllAttributes, getAttribute, getAttributeBooleanValue, getAttributeQNameValue, getAttributes, getAttributes, getAttributeStringValue, getAttributeValue, getBase, getBase, getBaseURI, getBooleanValue, getChild, getContainer, getContainerDocumentURI, getDeclaredNamespaces, getDocument, getElementsHashCode, getFragment, getFriendlyName, getFriendlyName, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getGenericLabelText, getId, getLang, getNamespaceURI, getNodeName, getNumberOfAttributes, getNumberOfElements, getNumberOfFromRelationships, getNumberOfToRelationships, getOrGenerateId, getParent, getPrefix, getPrefixes, getQNameValue, getRelationshipsBases, getRelationshipsChain, getRelationshipTypes, getStaticContext, getStaticNamespace, getStringValue, getToolTipText, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getXPathExecutable, getXPathNamespaceContext, getXPathToNode, getXPathToRoot, getXPointerElementScheme, getXPointerElementScheme, getXPointerShorthandScheme, getXPointerToNode, isDead, isNamespaceDefined, isXdmDocumentAttached, objEquals, objHashCode, qNameToString, removeAttribute, removeChild, removeChild, removeFromRelationship, removeToRelationship, removeXMLChild, resetElements, resetHash, resolve_equal2, resolveHRef, resolveHRef, s_equal2, s_equal2, setAttributes, setBase, setDocument, setDocumentAndReload, setElements, setId, setLang, setNamespaceContext, setNamespaces, setNode, setNodeName, setParent, setRegenerateNodeIfnotFound, setValue, setValue, setVariablesDefined, size, thin, toString, valueEquals, xEqual`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### entityNode

          public static final javax.xml.namespace.QName entityNode

      The Constant entityNode.

  - ### Constructor Detail

    - #### XBRLEntity

          public XBRLEntity(DTSContainer parent,
                    net.sf.saxon.s9api.XdmNode node)

      Instantiates a new XBRL entity.
      Parameters:
        `parent` - the parent
        `node` - the node

    - #### XBRLEntity

          public XBRLEntity(DTSContainer parent,
                    java.lang.String scheme,
                    java.lang.String identifier,
                    XBRLSegment segment)

      Creates a new Entity to be added to a context later. null parameters are permitted except for the parent parameter.
      Parameters:
        `parent` - - DTSContainer the DTS object
        `scheme` - - String the scheme URI string, may be null
        `identifier` - - String the company name token, may be null
        `segment` - - XBRLSegment the content of the segment, may be null

    - #### XBRLEntity

          public XBRLEntity(XBRLEntity other)

      Instantiates a new XBRL entity.
      Parameters:
        `other` - the other

  - ### Method Detail

    - #### clear

          public void clear()
                     throws java.lang.Throwable

      Description copied from class: `XMLFragment`
      Frees-up used memory

      This method should not be invoqued on live objects in the DTS. It is automatically invoqued by the API when an object is no longer used and referenced by other objects. It is save not to call it directly.

      Overrides:
        `clear` in class `XMLFragment`
      Throws:
        `java.lang.Throwable` - the throwable

    - #### clone

          public XBRLEntity clone()

      Overrides:
        `clone` in class `XMLFragment`

    - #### clone

          public XBRLEntity clone(DTSContainer newDTS)

      Description copied from class: `XMLFragment`
      Clone.
      Overrides:
        `clone` in class `XMLFragment`
      Parameters:
        `newDTS` - the new dts
      Returns:
        the XML fragment

    - #### setScheme

          public void setScheme(java.lang.String scheme)

      Sets the scheme.
      Parameters:
        `scheme` - the new scheme

    - #### setIdentifier

          public void setIdentifier(java.lang.String identifier)

      Sets the identifier.
      Parameters:
        `identifier` - the new identifier

    - #### setSegment

          public void setSegment(XBRLSegment segment)

      Sets the segment.
      Parameters:
        `segment` - the new segment

    - #### getScheme

          public java.lang.String getScheme()

      Access to the value of the Scheme on this entity.
      Returns:
        String

    - #### getIdentifier

          public java.lang.String getIdentifier()

      Access to the identifier string on this entity.
      Returns:
        String

    - #### getIdentifierNode

          public net.sf.saxon.s9api.XdmNode getIdentifierNode()

      In principle this is used only within the formula processor. This method returns the identifier node inside the entity. This class handles the values of the identifier node as text and the identifier node is internally created or read when it is needed.
      Returns:
        XdmItem
      See Also:
        `getIdentifier()`

    - #### getSegment

          public XBRLSegment getSegment()

      Access to the segment object of this entity.
      Returns:
        a XBRLSegment object or a new empty segment

    - #### equals

          public boolean equals(java.lang.Object other)

      Description copied from class: `XMLFragment`
      Sets a new XPathFunctionResolver for this object.
      Overrides:
        `equals` in class `XMLFragment`
      Parameters:
        `other` - the other
      Returns:
        true, if successful

    - #### s_equal2

          public boolean s_equal2(java.lang.Object other)

      Description copied from class: `XMLFragment`
      Resolves s_equal2 comparison of this node against the other node.
      Overrides:
        `s_equal2` in class `XMLFragment`
      Parameters:
        `other` - The other node (preferably an XMLFragment) that contains a non null NodeInfo document.
      Returns:
        boolean

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `XMLFragment`

    - #### generateNode

          public org.jdom.Element generateNode(boolean relativize,
                                      java.net.URI base)
                                        throws XBRLSerializationException

      Description copied from class: `XMLFragment`
      Serializes to a jdom Element the representation of the properties of this Information Item This method should be called from classes derived from this class
      Overrides:
        `generateNode` in class `XMLFragment`
      Parameters:
        `relativize` - boolean indicating if URIs should be relativized to the base URI (see next argument)
        `base` - the URI to which some attributes of this object should be relativided
      Returns:
        a clone of the surrounding jdom Element so it can be incorporated into multiple trees
      Throws:
        `XBRLSerializationException` - the XBRL serialization exception

    - #### getValue

          public net.sf.saxon.s9api.XdmValue getValue()

      Description copied from class: `XMLFragment`
      Returns the value of this node. If the value has been set to a jdom node then this function returns null If getDocument() is null then this function returns an empty sequence If getDocument() is not null this function tries to return an atomic value this function should be overridden by objects in this API
      Overrides:
        `getValue` in class `XMLFragment`
      Returns:
        a net.sf.saxon.s9api.XdmValue

    - #### getElements

          public java.util.Iterator<XMLFragment> getElements()

      Description copied from class: `XMLFragment`
      For complex type resources this returns an iterator with all children XML fragments This method may be overwriten by other classes in the hierarchy.
      Overrides:
        `getElements` in class `XMLFragment`
      Returns:
        Iterator